#include <stdlib.h>
#include <sys/ptrace.h>
#include <sys/time.h>
#include <stdio.h>
#include <errno.h>

double get_time_ms()
{
  static struct timeval last;
  static struct timeval this;
  double delta;
  gettimeofday(&this, NULL);

  delta = this.tv_sec - last.tv_sec + (this.tv_usec - last.tv_usec)/ 1000000.0 ;
  last = this;
  return delta; 
 
}


int main(int argc, char** argv)
{
        int wait_val;           /*  child's return value        */
        int pid;                /*  child's process id          */
	int n; 
	n = 2;

	if (argc < 3)
	  {
	    printf("Usage: ptrace_test pid addr1 addr2 ...\n"
		   "Returns time taken to read a word from specified addresses\n");
	    exit(1);
	  }
	pid = atoi(argv[1]);

	errno = 0;
        ptrace(PTRACE_ATTACH, pid, 0, 0);
	if (errno) {fprintf(stderr, "Failed to atttach\n"); exit(1);}
	wait(&wait_val); 
	get_time_ms();
	while (n < argc) {
	  void* addr;
	  double d;
	  long res;
	  addr = (void*) strtoul(argv[n], NULL, 10);
	  errno = 0;
	  res = ptrace(PTRACE_PEEKDATA, pid, addr, NULL);
	  if (errno) {fprintf(stderr, "Failed to read\n"); exit(1);}
	  d = get_time_ms();
	  printf("%6f secs to read address %lu (returned contents %ld)\n", d, addr, res);

	  n++;
	}

	ptrace(PTRACE_DETACH, pid, 0, 0);
}
